/* ADA "is" keyword. */
/* Taken from Baker (1981) JCSS 22: 243--259.  Updated against the ADA83 RM. */

%token PROCEDURE identifier IS NEW generic_procedure_name SEPARATE
%%

declarative_part
  : subprogram_body
  | body_stub
  | generic_instantiation
  ;

subprogram_body
  : subprogram_specification IS declarative_part_opt
  ;

declarative_part_opt
  : /* empty */
  ;

body_stub
  : subprogram_specification IS SEPARATE
  ;

subprogram_specification
  : PROCEDURE identifier formal_part_opt
  ;

formal_part_opt
  : /* empty */
  ;

generic_instantiation
  : PROCEDURE identifier IS NEW generic_procedure_name
  ;
