/* Java casts */
/* See <http://java.sun.com/docs/books/jls/first_edition/html/19.doc.html#44559> */

%token Name
%start Expression

%%

PrimitiveType
  : Name
  ;

Expression
  : UnaryExpression
  ;

UnaryExpression
  : UnaryExpressionNotPlusMinus
  ;

UnaryExpressionNotPlusMinus
  : PostfixExpression
  | CastExpression
  ;

PostfixExpression
  : Primary
  | Name
  ;

Primary
  : '(' Expression ')'
  ;

CastExpression
  : '(' PrimitiveType ')' UnaryExpression
  ;
