/* Pascal identifiers declarations typed in the grammar. */
/* G9 in Tai (1979), TOPLAS 1(2):295--320 */

%token VAR IDENTIFIER INTEGER REAL
%%

declaration
  : VAR integer_id_list integer_type ';'
  | VAR real_id_list real_type ';'
  ;

integer_id_list
  : IDENTIFIER ',' integer_id_list
  | IDENTIFIER
  ;

integer_type
  : ':' INTEGER
  ;

real_id_list
  : IDENTIFIER ',' real_id_list
  | IDENTIFIER
  ;

real_type
  : ':' REAL
  ;
